#!python

"""
    seal.py
    
    a simple file encryption and decryption program using Rotor, 
    a software implementation of the German Enigma machine of 
    WW II.  The cryptography is not especially strong, so the 
    use of this program and its cryptography should be limited 
    to educational and low-value tasks.
    
    Larry Bugbee
    rev June 2006
"""

import rotor, sys

numrotors = 6
numargs = len(sys.argv)

if numargs < 4:
    print '\n  usage: python seal.py e|d <filename> <pswd> [rotors]'
    print '          (default number of rotors: %d) \n' % numrotors
    sys.exit()

if numargs == 5:
    numrotors = int(sys.argv[4])
pswd = sys.argv[3]
file = sys.argv[2]
actn = sys.argv[1]

r = rotor.newrotor(pswd)

if actn == 'e':                     # encrypt
    fi = open(file)
    tx = fi.read()
    fi.close()
    ct = r.encrypt(tx)
    fo = open(file+'.r%d' % numrotors, 'wb')
    fo.write(ct)
    fo.close()
elif actn == 'd':                   # decrypt
    dot = file.rfind('.')
    if file[dot:dot+2] != '.r':
        print '\n  *** rename with a .rn suffix ***\n'
        sys.exit()
    fi = open(file)
    ct = fi.read()
    fi.close()
    tx = r.decrypt(ct)
    fo = open(file[:dot], 'wb')
    fo.write(tx)
    fo.close()
else:
    print '\n  *** do not understand "%s" *** \n' % actn
